<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class DeviceProps extends \Google\Protobuf\Internal\Message
{
    


    protected $os = null;
    


    protected $version = null;
    


    protected $platformType = null;
    


    protected $requireFullSync = null;
    


    protected $historySyncConfig = null;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getOs()
    {
        return isset($this->os) ? $this->os : '';
    }

    public function hasOs()
    {
        return isset($this->os);
    }

    public function clearOs()
    {
        unset($this->os);
    }

    




    public function setOs($var)
    {
        GPBUtil::checkString($var, True);
        $this->os = $var;

        return $this;
    }

    



    public function getVersion()
    {
        return $this->version;
    }

    public function hasVersion()
    {
        return isset($this->version);
    }

    public function clearVersion()
    {
        unset($this->version);
    }

    




    public function setVersion($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\DeviceProps\AppVersion::class);
        $this->version = $var;

        return $this;
    }

    



    public function getPlatformType()
    {
        return isset($this->platformType) ? $this->platformType : 0;
    }

    public function hasPlatformType()
    {
        return isset($this->platformType);
    }

    public function clearPlatformType()
    {
        unset($this->platformType);
    }

    




    public function setPlatformType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\DeviceProps\PlatformType::class);
        $this->platformType = $var;

        return $this;
    }

    



    public function getRequireFullSync()
    {
        return isset($this->requireFullSync) ? $this->requireFullSync : false;
    }

    public function hasRequireFullSync()
    {
        return isset($this->requireFullSync);
    }

    public function clearRequireFullSync()
    {
        unset($this->requireFullSync);
    }

    




    public function setRequireFullSync($var)
    {
        GPBUtil::checkBool($var);
        $this->requireFullSync = $var;

        return $this;
    }

    



    public function getHistorySyncConfig()
    {
        return $this->historySyncConfig;
    }

    public function hasHistorySyncConfig()
    {
        return isset($this->historySyncConfig);
    }

    public function clearHistorySyncConfig()
    {
        unset($this->historySyncConfig);
    }

    




    public function setHistorySyncConfig($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\DeviceProps\HistorySyncConfig::class);
        $this->historySyncConfig = $var;

        return $this;
    }

}

